libcamera: libcamera::ipa::ipu3::IPAActiveState Struct Reference

libcamera v0.3.2 Supporting cameras in Linux since 2019

Loading...
Searching...
No Matches
Public Attributes | List of all members
libcamera::ipa::ipu3::IPAActiveState Struct Reference

The active state of the IPA algorithms. More...

## Public Attributes
struct { |
uint32_t focus |
double maxVariance |
bool stable |
} | af |
| Context for the Automatic Focus algorithm.
struct { |
uint32_t exposure |
double gain |
uint32_t constraintMode |
uint32_t exposureMode |
} | agc |
| Context for the Automatic Gain Control algorithm.
struct { |
struct { |
double red |
double green |
double blue |
} gains |
double temperatureK |
} | awb |
| Context for the Automatic White Balance algorithm.
struct { |
double gamma |
struct ipu3_uapi_gamma_corr_lut gammaCorrection |
} | toneMapping |
| Context for ToneMapping and Gamma control.

## Detailed Description

The active state of the IPA algorithms.

The IPA is fed with the statistics generated from the latest frame captured by the hardware. The statistics are then processed by the IPA algorithms to compute ISP parameters required for the next frame capture. The current state of the algorithms is reflected through the IPAActiveState to store the values most recently computed by the IPA algorithms.

## Member Data Documentation

## ◆ [struct]

struct { ... } libcamera::ipa::ipu3::IPAActiveState::agc

Context for the Automatic Gain Control algorithm.

The exposure and gain determined are expected to be applied to the sensor at the earliest opportunity.

## ◆ gain

double libcamera::ipa::ipu3::IPAActiveState::gain

Analogue gain multiplier.

The gain should be adapted to the sensor specific gain code before applying.

## ◆ gammaCorrection

struct ipu3_uapi_gamma_corr_lut libcamera::ipa::ipu3::IPAActiveState::gammaCorrection

Per-pixel tone mapping implemented as a LUT.

The LUT structure is defined by the IPU3 kernel interface. See <linux/intel-ipu3.h> struct ipu3_uapi_gamma_corr_lut for further details.

The documentation for this struct was generated from the following files:

- src/ipa/ipu3/ipa_context.h
- src/ipa/ipu3/ipa_context.cpp